/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


/*=========================================================================
  Program:   bbtk
  Module:    $RCSfile: bbstdToString.cxx,v $
  Language:  C++
  Date:      $Date: 2012/11/16 08:51:32 $
  Version:   $Revision: 1.5 $
=========================================================================*/

#include "bbstdToString.h"
#include "bbstdPackage.h"
#include <sstream>

 
namespace bbstd 
{

  //====================================================================
  BBTK_BLACK_BOX_TEMPLATE_IMPLEMENTATION(ToString,
					 bbtk::AtomicBlackBox);
  //====================================================================
  
  //====================================================================
  template <class T> void ToString<T> ::DoIt()
  {
//    std::ostringstream s;
//    s <<  bbGetInputIn(); 
//    bbSetOutputOut( s.str() );
    bbSetOutputOut( std::to_string( bbGetInputIn() ) );
  }
  //====================================================================
  
  //====================================================================
  // Add the specialized adaptors to the package
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,bool);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,int8_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,uint8_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,int16_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,uint16_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,int32_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,uint32_t);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,float);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,double);
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(std,ToString,long);
  //====================================================================
  

} // namespace bbstd

