/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbvtkImageBoundaries_h_INCLUDED__
#define __bbvtkImageBoundaries_h_INCLUDED__
#include "bbvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkVersion.h"

#include <vtkImageData.h>

namespace bbvtk
{

class bbvtk_EXPORT ImageBoundaries
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ImageBoundaries,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
	BBTK_DECLARE_INPUT(In,vtkImageData*);
	BBTK_DECLARE_INPUT(LowerValue,double);
	BBTK_DECLARE_INPUT(UpperValue,double);
	BBTK_DECLARE_OUTPUT(Index,std::vector<int>);
	BBTK_DECLARE_OUTPUT(Size,std::vector<int>);
  BBTK_PROCESS(Process);
  void Process();
	

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ImageBoundaries,bbtk::AtomicBlackBox);
	BBTK_NAME("ImageBoundaries");
	BBTK_AUTHOR("Info-Dev");
	BBTK_DESCRIPTION("Get gray level boundaries of an vtkImageData (for AutoCrop)");
	BBTK_CATEGORY("filter");
	BBTK_INPUT(ImageBoundaries,In,"Input image",vtkImageData*,"");
	BBTK_INPUT(ImageBoundaries,LowerValue,"0 default. Lower gray level",double,"");
	BBTK_INPUT(ImageBoundaries,UpperValue,"5000 default. Upper gray level",double,"");
	BBTK_OUTPUT(ImageBoundaries,Index,"Start point of the boundarie",std::vector<int>,"");
	BBTK_OUTPUT(ImageBoundaries,Size,"Size of the boundarie from start",std::vector<int>,"");
BBTK_END_DESCRIBE_BLACK_BOX(ImageBoundaries);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbvtk

#endif // __bbvtkImageBoundaries_h_INCLUDED__

